From 69c3e12d1c701db768355ef93445774e069e7a37 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 22 2017 17:21:45 +0000
Subject: [PATCH 759/1001] Let widgets declare their add and edit config urls


This way, widgets can have a more complex configuration panel.

---

diff --git a/hubs/models.py b/hubs/models.py
index 2c155b9..3464f5b 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -360,6 +360,10 @@ class Widget(BASE):
     def module(self):
         return hubs.widgets.registry[self.plugin]
 
+    @property
+    def edit_url(self):
+        return self.module.get_edit_url(self.hub, self)
+
 
 class User(BASE):
     __tablename__ = 'users'
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index 773e357..60b1326 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -4,8 +4,10 @@ import datetime
 import flask
 
 from hubs.app import app
+from hubs.models import Widget
+from hubs.widgets import registry
 from pkg_resources import resource_isdir
-from .utils import get_widget_instance, login_required
+from .utils import get_hub, get_widget_instance, login_required
 
 
 @app.route('/<hub>/<int:idx>/json')
@@ -17,7 +19,59 @@ def widget_json(hub, idx):
     return response
 
 
-@app.route('/<hub>/<int:idx>/edit/', methods=['GET', 'POST'])
+@app.route('/<hub>/add/<widget>', methods=['GET', 'POST'])
+def widget_add(hub, widget):
+    hub = get_hub(hub)
+    position = flask.request.values.get('position', '')
+    if position not in ['right', 'left']:
+        flask.abort(400, 'Invalid position provided')
+    try:
+        widget = registry[widget]
+    except KeyError:
+        flask.abort(404, 'Unknown widget: %s' % widget)
+    if flask.request.method == 'POST':
+        create_widget_instance(hub, widget, position)
+        return flask.redirect(flask.url_for('hub_edit', name=hub.name))
+    return flask.render_template(
+        'widget_add.html',
+        hub=hub,
+        widget=widget,
+        position=position,
+    )
+
+def create_widget_instance(hub, widget, position):
+    """View helper to instanciate a widget on a hub."""
+    widget_instance = Widget(
+        hub=hub, plugin=widget.name, index=-1,
+        left=(position == 'left'))
+    config = {}
+    for param in widget.get_parameters():
+        val = flask.request.form.get(param.name)
+        if not val:
+            flask.flash(
+                'You must provide a value for: %s' % param.name, 'error')
+            return
+        try:
+            config[param.name] = param.validator.from_string(val)
+        except Exception as err:
+            flask.flash('Invalid data provided, error: %s' % err, 'error')
+            return
+    widget_instance.config = config
+    try:
+        flask.g.db.add(widget_instance)
+        flask.g.db.flush()
+        # TODO: use a SQLAlchemy signal here
+        hub.last_edited = datetime.datetime.utcnow()
+        flask.g.db.commit()
+    except Exception as err:
+        flask.flash(
+            'Could not save the configuration to the database '
+            'if the error persists, please warn an admin',
+            'error')
+    else:
+        flask.flash("The widget has been added.")
+
+
 @app.route('/<hub>/<int:idx>/edit', methods=['GET', 'POST'])
 @login_required
 def widget_edit(hub, idx):
@@ -28,20 +82,19 @@ def widget_edit(hub, idx):
 
 
 def widget_edit_get(hub, idx):
-    widget = get_widget_instance(hub, idx)
+    widget_instance = get_widget_instance(hub, idx)
     return flask.render_template(
-        'edit.html',
-        hub=hub,
-        widget=widget,
-        url_to=flask.url_for('widget_edit', hub=hub, idx=idx)
+        'widget_edit.html',
+        hub=widget_instance.hub,
+        widget_instance=widget_instance,
     )
 
 
 def widget_edit_post(hub, idx):
-    widget = get_widget_instance(hub, idx)
+    widget_instance = get_widget_instance(hub, idx)
     error = False
     config = {}
-    for param in widget.module.get_parameters():
+    for param in widget_instance.module.get_parameters():
         val = flask.request.form.get(param.name)
         if not val:
             flask.flash(
@@ -49,17 +102,17 @@ def widget_edit_post(hub, idx):
             error = True
             break
         try:
-            val = param.validator.from_string(val)
-            config[param.name] = val
+            config[param.name] = param.validator.from_string(val)
         except Exception as err:
             flask.flash('Invalid data provided, error: %s' % err, 'error')
             error = True
     if not error:
-        cur_config = widget.config
+        # Updating in-place is not supported, it's a class property.
+        cur_config = widget_instance.config.copy()
         cur_config.update(config)
-        widget.config = cur_config
-        widget.hub.last_edited = datetime.datetime.utcnow()
-        flask.g.db.add(widget)
+        widget_instance.config = cur_config
+        widget_instance.hub.last_edited = datetime.datetime.utcnow()
+        flask.g.db.add(widget_instance)
         try:
             flask.g.db.commit()
         except Exception as err:
@@ -67,7 +120,7 @@ def widget_edit_post(hub, idx):
                 'Could not save the configuration to the database '
                 'if the error persists, please warn an admin',
                 'error')
-    return flask.redirect(flask.url_for('hub', name=hub))
+    return flask.redirect(flask.url_for('hub_edit', name=hub))
 
 
 @app.route('/<hub>/<int:idx>/delete/', methods=['POST'])
@@ -90,8 +143,6 @@ def widget_edit_delete(hub, idx):
 @app.route('/source/<name>/')
 @app.route('/source/<name>')
 def widget_source(name):
-    from hubs.widgets import registry
-
     try:
         widget_path = registry[name].__module__
     except KeyError:
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 38da840..8ae225a 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -52,7 +52,7 @@ class Widget(object):
     """
     The main widget class, you must subclass it to create a widget.
 
-    Arguments:
+    Attributes:
         name (str): The widget name. It will not be displayed in the UI, but
             will appear in some URLs, so be careful to only use simple,
             URL-compatible characters.
@@ -194,6 +194,39 @@ class Widget(object):
                     self.name, url_rule.lstrip("/"))
                 app.add_url_rule(rule, view_func=view_func)
 
+    def get_add_url(self, hub, position):
+        """Returns the URL to the configuration panel to add this widget.
+
+        By default, it returns the URL to the common widget configuration panel
+        that will simply display the widget's parameters in a form.  Widgets
+        override this method to implement a more complex configuration view.
+
+        If a more complex configuration view is implemented, the resulting HTML
+        code will be wrapped in a ``<div class="modal-dialog">`` tag.
+
+        Args:
+            hub (hubs.models.Hub): The hub instance in the database.
+            position (str): the position where the widget should be added. It
+                must be either ``left`` or ``right``, and must be in the
+                supported positions for this widget (see :py:attr:`position`).
+        """
+        return "%s?position=%s" % (
+            flask.url_for('widget_add', hub=hub.name, widget=self.name),
+            position)
+
+    def get_edit_url(self, hub, widget_instance):
+        """Returns the URL to the configuration panel to edit this widget.
+
+        This method works like :py:meth:`get_add_url`.
+
+        Args:
+            hub (hubs.models.Hub): The hub instance in the database.
+            widget_instance (hubs.models.Widget): The widget instance in the
+                database that must be configured.
+        """
+        return flask.url_for(
+            'widget_edit', hub=hub.name, idx=widget_instance.idx)
+
     def get_cached_functions(self):
         """
         Returns:
